import{S as ql,i as Tl,s as Sl,e as a,k as c,w as b,t as r,N as Wl,c as o,d as t,m as u,a as l,x as v,h as i,b as h,P as ot,G as s,g as p,y as k,q as j,o as E,B as $,v as Al}from"../chunks/vendor-hf-doc-builder.js";import{T as Ol}from"../chunks/Tip-hf-doc-builder.js";import{I as St}from"../chunks/IconCopyLink-hf-doc-builder.js";import{C as Wt}from"../chunks/CodeBlock-hf-doc-builder.js";function xl(At){let f,w,m,d,W,g;return{c(){f=a("p"),w=a("strong"),m=r("Join the "),d=a("a"),W=r("webhooks-explorers"),g=r(" organization to beta-test webhooks!"),this.h()},l(A){f=o(A,"P",{});var P=l(f);w=o(P,"STRONG",{});var R=l(w);m=i(R,"Join the "),d=o(R,"A",{href:!0,rel:!0});var ee=l(d);W=i(ee,"webhooks-explorers"),ee.forEach(t),g=i(R," organization to beta-test webhooks!"),R.forEach(t),P.forEach(t),this.h()},h(){h(d,"href","https://huggingface.co/webhooks-explorers"),h(d,"rel","nofollow")},m(A,P){p(A,f,P),s(f,w),s(w,m),s(w,d),s(d,W),s(w,g)},d(A){A&&t(f)}}}function Hl(At){let f,w,m,d,W,g,A,P,R,ee,N,Ot,We,As,xt,q,Os,te,xs,Hs,se,Ls,Cs,Ht,O,F,lt,ae,Is,nt,Rs,Lt,T,Ns,oe,Fs,Us,le,Ds,Bs,Ct,Ae,Oe,ho,It,x,U,rt,ne,Ms,it,Ys,Rt,D,Ks,re,Gs,Js,Nt,y,ie,Xs,pe,zs,Vs,Qs,pt,Zs,ea,ht,ta,sa,ct,aa,Ft,xe,oa,Ut,He,Le,co,Dt,H,B,ut,he,la,ft,na,Bt,M,ra,ce,ia,pa,Mt,Y,ha,ue,ca,ua,Yt,_,fa,fe,da,ma,de,wa,ya,me,_a,ga,Kt,K,ba,we,va,ka,Gt,Ce,L,ja,dt,Ea,$a,mt,Pa,qa,Jt,ye,Xt,_e,wt,Ie,C,Ta,yt,Sa,Wa,_t,Aa,Oa,zt,ge,Vt,be,gt,xa,Qt,G,bt,Ha,La,vt,Ca,Zt,ve,es,ke,je,Ia,kt,Ra,Na,ts,Ee,ss,Re,Fa,as,Ne,Fe,uo,os,Ue,Ua,ls,De,Da,ns,J,Be,jt,Ba,Ma,Ya,S,Et,Ka,Ga,$t,Ja,Xa,$e,za,Va,rs,X,Qa,z,Pt,Za,eo,to,is,Pe,ps,I,V,qt,qe,so,Tt,ao,hs,Me,oo,cs,Ye,lo,us,Ke,Ge,fo,fs,Je,Xe,mo,ds,ze,no,ms,Ve,Qe,wo,ws,Ze,ro,ys;return g=new St({}),N=new Ol({props:{warning:!0,$$slots:{default:[xl]},$$scope:{ctx:At}}}),ae=new St({}),ne=new St({}),he=new St({}),ye=new Wt({props:{code:`from fastapi import FastAPI

# [...]
@app.post("/webhook")
async def post_webhook(
	# ...
):

# ...`,highlighted:`<span class="hljs-keyword">from</span> fastapi <span class="hljs-keyword">import</span> FastAPI

<span class="hljs-comment"># [...]</span>
<span class="hljs-meta">@app.post(<span class="hljs-params"><span class="hljs-string">&quot;/webhook&quot;</span></span>)</span>
<span class="hljs-keyword">async</span> <span class="hljs-keyword">def</span> <span class="hljs-title function_">post_webhook</span>(<span class="hljs-params">
	<span class="hljs-comment"># ...</span>
</span>):

<span class="hljs-comment"># ...</span>`}}),ge=new Wt({props:{code:`# [...]

WEBHOOK_SECRET = os.getenv("WEBHOOK_SECRET")

# [...]

@app.post("/webhook")
async def post_webhook(
	# [...]
	x_webhook_secret:  Optional[str] = Header(default=None),
	# ^ checks for the X-Webhook-Secret HTTP header
):
	if x_webhook_secret is None:
		raise HTTPException(401)
	if x_webhook_secret != WEBHOOK_SECRET:
		raise HTTPException(403)
	# [...]`,highlighted:`<span class="hljs-comment"># [...]</span>

WEBHOOK_SECRET = os.getenv(<span class="hljs-string">&quot;WEBHOOK_SECRET&quot;</span>)

<span class="hljs-comment"># [...]</span>

<span class="hljs-meta">@app.post(<span class="hljs-params"><span class="hljs-string">&quot;/webhook&quot;</span></span>)</span>
<span class="hljs-keyword">async</span> <span class="hljs-keyword">def</span> <span class="hljs-title function_">post_webhook</span>(<span class="hljs-params">
	<span class="hljs-comment"># [...]</span>
	x_webhook_secret:  <span class="hljs-type">Optional</span>[<span class="hljs-built_in">str</span>] = Header(<span class="hljs-params">default=<span class="hljs-literal">None</span></span>),
	<span class="hljs-comment"># ^ checks for the X-Webhook-Secret HTTP header</span>
</span>):
	<span class="hljs-keyword">if</span> x_webhook_secret <span class="hljs-keyword">is</span> <span class="hljs-literal">None</span>:
		<span class="hljs-keyword">raise</span> HTTPException(<span class="hljs-number">401</span>)
	<span class="hljs-keyword">if</span> x_webhook_secret != WEBHOOK_SECRET:
		<span class="hljs-keyword">raise</span> HTTPException(<span class="hljs-number">403</span>)
	<span class="hljs-comment"># [...]</span>`}}),ve=new Wt({props:{code:`# defined in src/models.py
class WebhookPayloadEvent(BaseModel):
	action: Literal["create", "update", "delete"]
	scope: str

class WebhookPayloadRepo(BaseModel):
	type: Literal["dataset", "model", "space"]
	name: str
	id: str
	private: bool
	headSha: str

class WebhookPayload(BaseModel):
	event: WebhookPayloadEvent
	repo: WebhookPayloadRepo

# [...]

@app.post("/webhook")
async def post_webhook(
	# [...]
	payload: WebhookPayload,
	# ^ Pydantic model defining the payload format
):
	# [...]
	if not (
		payload.event.action == "update"
		and payload.event.scope.startswith("repo.content")
		and payload.repo.name == config.input_dataset
		and payload.repo.type == "dataset"
	):
		# no-op if the payload does not match our expectations
		return {"processed": False}
	#[...]`,highlighted:`<span class="hljs-comment"># defined in src/models.py</span>
<span class="hljs-keyword">class</span> <span class="hljs-title class_">WebhookPayloadEvent</span>(<span class="hljs-title class_ inherited__">BaseModel</span>):
	action: <span class="hljs-type">Literal</span>[<span class="hljs-string">&quot;create&quot;</span>, <span class="hljs-string">&quot;update&quot;</span>, <span class="hljs-string">&quot;delete&quot;</span>]
	scope: <span class="hljs-built_in">str</span>

<span class="hljs-keyword">class</span> <span class="hljs-title class_">WebhookPayloadRepo</span>(<span class="hljs-title class_ inherited__">BaseModel</span>):
	<span class="hljs-built_in">type</span>: <span class="hljs-type">Literal</span>[<span class="hljs-string">&quot;dataset&quot;</span>, <span class="hljs-string">&quot;model&quot;</span>, <span class="hljs-string">&quot;space&quot;</span>]
	name: <span class="hljs-built_in">str</span>
	<span class="hljs-built_in">id</span>: <span class="hljs-built_in">str</span>
	private: <span class="hljs-built_in">bool</span>
	headSha: <span class="hljs-built_in">str</span>

<span class="hljs-keyword">class</span> <span class="hljs-title class_">WebhookPayload</span>(<span class="hljs-title class_ inherited__">BaseModel</span>):
	event: WebhookPayloadEvent
	repo: WebhookPayloadRepo

<span class="hljs-comment"># [...]</span>

<span class="hljs-meta">@app.post(<span class="hljs-params"><span class="hljs-string">&quot;/webhook&quot;</span></span>)</span>
<span class="hljs-keyword">async</span> <span class="hljs-keyword">def</span> <span class="hljs-title function_">post_webhook</span>(<span class="hljs-params">
	<span class="hljs-comment"># [...]</span>
	payload: WebhookPayload,
	<span class="hljs-comment"># ^ Pydantic model defining the payload format</span>
</span>):
	<span class="hljs-comment"># [...]</span>
	<span class="hljs-keyword">if</span> <span class="hljs-keyword">not</span> (
		payload.event.action == <span class="hljs-string">&quot;update&quot;</span>
		<span class="hljs-keyword">and</span> payload.event.scope.startswith(<span class="hljs-string">&quot;repo.content&quot;</span>)
		<span class="hljs-keyword">and</span> payload.repo.name == config.input_dataset
		<span class="hljs-keyword">and</span> payload.repo.<span class="hljs-built_in">type</span> == <span class="hljs-string">&quot;dataset&quot;</span>
	):
		<span class="hljs-comment"># no-op if the payload does not match our expectations</span>
		<span class="hljs-keyword">return</span> {<span class="hljs-string">&quot;processed&quot;</span>: <span class="hljs-literal">False</span>}
	<span class="hljs-comment">#[...]</span>`}}),Ee=new Wt({props:{code:`def schedule_retrain(payload: WebhookPayload):
	# Create the autotrain project
	try:
		project = AutoTrain.create_project(payload)
		AutoTrain.add_data(project_id=project["id"])
		AutoTrain.start_processing(project_id=project["id"])
	except requests.HTTPError as err:
		print("ERROR while requesting AutoTrain API:")
		print(f"  code: {err.response.status_code}")
		print(f"  {err.response.json()}")
		raise
	# Notify in the community tab
	notify_success(project["id"])`,highlighted:`<span class="hljs-keyword">def</span> <span class="hljs-title function_">schedule_retrain</span>(<span class="hljs-params">payload: WebhookPayload</span>):
	<span class="hljs-comment"># Create the autotrain project</span>
	<span class="hljs-keyword">try</span>:
		project = AutoTrain.create_project(payload)
		AutoTrain.add_data(project_id=project[<span class="hljs-string">&quot;id&quot;</span>])
		AutoTrain.start_processing(project_id=project[<span class="hljs-string">&quot;id&quot;</span>])
	<span class="hljs-keyword">except</span> requests.HTTPError <span class="hljs-keyword">as</span> err:
		<span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;ERROR while requesting AutoTrain API:&quot;</span>)
		<span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;  code: <span class="hljs-subst">{err.response.status_code}</span>&quot;</span>)
		<span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;  <span class="hljs-subst">{err.response.json()}</span>&quot;</span>)
		<span class="hljs-keyword">raise</span>
	<span class="hljs-comment"># Notify in the community tab</span>
	notify_success(project[<span class="hljs-string">&quot;id&quot;</span>])`}}),Pe=new Wt({props:{code:`{
	"target_namespace": "the namespace where the trained model should end up",
	"input_dataset": "the dataset on which the model will be trained",
	"input_model": "the base model to re-train",
	"autotrain_project_prefix": "A prefix for the AutoTrain project"
}`,highlighted:`<span class="hljs-punctuation">{</span>
	<span class="hljs-attr">&quot;target_namespace&quot;</span><span class="hljs-punctuation">:</span> <span class="hljs-string">&quot;the namespace where the trained model should end up&quot;</span><span class="hljs-punctuation">,</span>
	<span class="hljs-attr">&quot;input_dataset&quot;</span><span class="hljs-punctuation">:</span> <span class="hljs-string">&quot;the dataset on which the model will be trained&quot;</span><span class="hljs-punctuation">,</span>
	<span class="hljs-attr">&quot;input_model&quot;</span><span class="hljs-punctuation">:</span> <span class="hljs-string">&quot;the base model to re-train&quot;</span><span class="hljs-punctuation">,</span>
	<span class="hljs-attr">&quot;autotrain_project_prefix&quot;</span><span class="hljs-punctuation">:</span> <span class="hljs-string">&quot;A prefix for the AutoTrain project&quot;</span>
<span class="hljs-punctuation">}</span>`}}),qe=new St({}),{c(){f=a("meta"),w=c(),m=a("h1"),d=a("a"),W=a("span"),b(g.$$.fragment),A=c(),P=a("span"),R=r("Webhook guide: Setup an automatic system to re-train a model when a dataset changes"),ee=c(),b(N.$$.fragment),Ot=c(),We=a("p"),As=r(`This guide will help walk you through the setup of an automatic training pipeline on the Hugging Face platform
using HF Datasets, Webhooks, Spaces, and AutoTrain.`),xt=c(),q=a("p"),Os=r(`We will build a Webhook that listens to changes on an image classification dataset and triggers a fine-tuning
of `),te=a("a"),xs=r("microsoft/resnet-50"),Hs=r(" using "),se=a("a"),Ls=r("AutoTrain"),Cs=r("."),Ht=c(),O=a("h2"),F=a("a"),lt=a("span"),b(ae.$$.fragment),Is=c(),nt=a("span"),Rs=r("Prerequisite: Upload your dataset to the Hub"),Lt=c(),T=a("p"),Ns=r("We will use a "),oe=a("a"),Fs=r("simple image classification dataset"),Us=r(` for the sake
of the example. Learn more about uploading your data to the Hub `),le=a("a"),Ds=r("here"),Bs=r("."),Ct=c(),Ae=a("p"),Oe=a("img"),It=c(),x=a("h2"),U=a("a"),rt=a("span"),b(ne.$$.fragment),Ms=c(),it=a("span"),Ys=r("Create a Webhook to react to the dataset's changes"),Rt=c(),D=a("p"),Ks=r("First, let\u2019s create a Webhook from your "),re=a("a"),Gs=r("settings"),Js=r("."),Nt=c(),y=a("ul"),ie=a("li"),Xs=r("Select your dataset as the target repository. We will target "),pe=a("a"),zs=r("huggingface-projects/input-dataset"),Vs=r(" in this example."),Qs=c(),pt=a("li"),Zs=r("You can put a dummy Webhook URL for now. Defining your Webhook will let you look at the events that will be sent to it. You can also replay them, which will be useful for debugging!"),ea=c(),ht=a("li"),ta=r("Input a secret to make it more secure."),sa=c(),ct=a("li"),aa=r("Subscribe to \u201CRepo update\u201D events as we want to react to data changes"),Ft=c(),xe=a("p"),oa=r("Your Webhook will look like this:"),Ut=c(),He=a("p"),Le=a("img"),Dt=c(),H=a("h2"),B=a("a"),ut=a("span"),b(he.$$.fragment),la=c(),ft=a("span"),na=r("Create a Space to react to your Webhook"),Bt=c(),M=a("p"),ra=r("We now need a way to react to your Webhook events. An easy way to do this is to use a "),ce=a("a"),ia=r("Space"),pa=r("!"),Mt=c(),Y=a("p"),ha=r("You can find an example Space "),ue=a("a"),ca=r("here"),ua=r("."),Yt=c(),_=a("p"),fa=r("This Space uses Docker, Python, "),fe=a("a"),da=r("FastAPI"),ma=r(", and "),de=a("a"),wa=r("uvicorn"),ya=r(" to run a simple HTTP server. Read more about Docker Spaces "),me=a("a"),_a=r("here"),ga=r("."),Kt=c(),K=a("p"),ba=r("The entry point is "),we=a("a"),va=r("src/main.py"),ka=r(". Let\u2019s walk through this file and detail what it does:"),Gt=c(),Ce=a("ol"),L=a("li"),ja=r("It spawns a FastAPI app that will listen to HTTP "),dt=a("code"),Ea=r("POST"),$a=r(" requests on "),mt=a("code"),Pa=r("/webhook"),qa=r(":"),Jt=c(),b(ye.$$.fragment),Xt=c(),_e=a("ol"),wt=a("li"),Ie=a("ol"),C=a("li"),Ta=r("This route checks that the "),yt=a("code"),Sa=r("X-Webhook-Secret"),Wa=r(" header is present and that its value is the same as the one you set in your Webhook\u2019s settings. The "),_t=a("code"),Aa=r("WEBHOOK_SECRET"),Oa=r(" secret must be set in the Space\u2019s settings and be the same as the secret set in your Webhook."),zt=c(),b(ge.$$.fragment),Vt=c(),be=a("ol"),gt=a("li"),xa=r("The event\u2019s payload is encoded as JSON. Here, we\u2019ll be using pydantic models to parse the event payload. We also specify that we will run our Webhook only when:"),Qt=c(),G=a("ul"),bt=a("li"),Ha=r("the event concerns the input dataset"),La=c(),vt=a("li"),Ca=r("the event is an update on the repo\u2019s content, i.e., there has been a new commit"),Zt=c(),b(ve.$$.fragment),es=c(),ke=a("ol"),je=a("li"),Ia=r("If the payload is valid, the next step is to create a project on AutoTrain, schedule a fine-tuning of the input model ("),kt=a("code"),Ra=r("microsoft/resnet-50"),Na=r(" in our example) on the input dataset, and create a discussion on the dataset when it\u2019s done!"),ts=c(),b(Ee.$$.fragment),ss=c(),Re=a("p"),Fa=r("Visit the link inside the comment to review the training cost estimate, and start fine-tuning the model!"),as=c(),Ne=a("p"),Fe=a("img"),os=c(),Ue=a("p"),Ua=r("In this example, we used Hugging Face AutoTrain to fine-tune our model quickly, but you can of course plug in your training infrastructure!"),ls=c(),De=a("p"),Da=r("Feel free to duplicate the Space to your personal namespace and play with it. You will need to provide two secrets:"),ns=c(),J=a("ul"),Be=a("li"),jt=a("code"),Ba=r("WEBHOOK_SECRET"),Ma=r(" : the secret from your Webhook."),Ya=c(),S=a("li"),Et=a("code"),Ka=r("HF_ACCESS_TOKEN"),Ga=r(" : a User Access Token with "),$t=a("code"),Ja=r("write"),Xa=r(" rights. You can create one "),$e=a("a"),za=r("from your settings"),Va=r("."),rs=c(),X=a("p"),Qa=r("You will also need to tweak the "),z=a("a"),Pt=a("code"),Za=r("config.json"),eo=r(" file"),to=r(" to use the dataset and model of you choice:"),is=c(),b(Pe.$$.fragment),ps=c(),I=a("h2"),V=a("a"),qt=a("span"),b(qe.$$.fragment),so=c(),Tt=a("span"),ao=r("Configure your Webhook to send events to your Space"),hs=c(),Me=a("p"),oo=r("Last but not least, you\u2019ll need to configure your webhook to send POST requests to your Space."),cs=c(),Ye=a("p"),lo=r("Let\u2019s first grab our Space\u2019s \u201Cdirect URL\u201D from the contextual menu. Click on \u201CEmbed this Space\u201D and copy the \u201CDirect URL\u201D."),us=c(),Ke=a("p"),Ge=a("img"),fs=c(),Je=a("p"),Xe=a("img"),ds=c(),ze=a("p"),no=r("Update your Webhook to send requests to that URL:"),ms=c(),Ve=a("p"),Qe=a("img"),ws=c(),Ze=a("p"),ro=r("And that\u2019s it! Now every commit to the input dataset will trigger a fine-tuning of ResNet-50 with AutoTrain \u{1F389}"),this.h()},l(e){const n=Wl('[data-svelte="svelte-1phssyn"]',document.head);f=o(n,"META",{name:!0,content:!0}),n.forEach(t),w=u(e),m=o(e,"H1",{class:!0});var Te=l(m);d=o(Te,"A",{id:!0,class:!0,href:!0});var yo=l(d);W=o(yo,"SPAN",{});var _o=l(W);v(g.$$.fragment,_o),_o.forEach(t),yo.forEach(t),A=u(Te),P=o(Te,"SPAN",{});var go=l(P);R=i(go,"Webhook guide: Setup an automatic system to re-train a model when a dataset changes"),go.forEach(t),Te.forEach(t),ee=u(e),v(N.$$.fragment,e),Ot=u(e),We=o(e,"P",{});var bo=l(We);As=i(bo,`This guide will help walk you through the setup of an automatic training pipeline on the Hugging Face platform
using HF Datasets, Webhooks, Spaces, and AutoTrain.`),bo.forEach(t),xt=u(e),q=o(e,"P",{});var et=l(q);Os=i(et,`We will build a Webhook that listens to changes on an image classification dataset and triggers a fine-tuning
of `),te=o(et,"A",{href:!0,rel:!0});var vo=l(te);xs=i(vo,"microsoft/resnet-50"),vo.forEach(t),Hs=i(et," using "),se=o(et,"A",{href:!0,rel:!0});var ko=l(se);Ls=i(ko,"AutoTrain"),ko.forEach(t),Cs=i(et,"."),et.forEach(t),Ht=u(e),O=o(e,"H2",{class:!0});var _s=l(O);F=o(_s,"A",{id:!0,class:!0,href:!0});var jo=l(F);lt=o(jo,"SPAN",{});var Eo=l(lt);v(ae.$$.fragment,Eo),Eo.forEach(t),jo.forEach(t),Is=u(_s),nt=o(_s,"SPAN",{});var $o=l(nt);Rs=i($o,"Prerequisite: Upload your dataset to the Hub"),$o.forEach(t),_s.forEach(t),Lt=u(e),T=o(e,"P",{});var tt=l(T);Ns=i(tt,"We will use a "),oe=o(tt,"A",{href:!0,rel:!0});var Po=l(oe);Fs=i(Po,"simple image classification dataset"),Po.forEach(t),Us=i(tt,` for the sake
of the example. Learn more about uploading your data to the Hub `),le=o(tt,"A",{href:!0,rel:!0});var qo=l(le);Ds=i(qo,"here"),qo.forEach(t),Bs=i(tt,"."),tt.forEach(t),Ct=u(e),Ae=o(e,"P",{});var To=l(Ae);Oe=o(To,"IMG",{src:!0,alt:!0}),To.forEach(t),It=u(e),x=o(e,"H2",{class:!0});var gs=l(x);U=o(gs,"A",{id:!0,class:!0,href:!0});var So=l(U);rt=o(So,"SPAN",{});var Wo=l(rt);v(ne.$$.fragment,Wo),Wo.forEach(t),So.forEach(t),Ms=u(gs),it=o(gs,"SPAN",{});var Ao=l(it);Ys=i(Ao,"Create a Webhook to react to the dataset's changes"),Ao.forEach(t),gs.forEach(t),Rt=u(e),D=o(e,"P",{});var bs=l(D);Ks=i(bs,"First, let\u2019s create a Webhook from your "),re=o(bs,"A",{href:!0,rel:!0});var Oo=l(re);Gs=i(Oo,"settings"),Oo.forEach(t),Js=i(bs,"."),bs.forEach(t),Nt=u(e),y=o(e,"UL",{});var Q=l(y);ie=o(Q,"LI",{});var vs=l(ie);Xs=i(vs,"Select your dataset as the target repository. We will target "),pe=o(vs,"A",{href:!0,rel:!0});var xo=l(pe);zs=i(xo,"huggingface-projects/input-dataset"),xo.forEach(t),Vs=i(vs," in this example."),vs.forEach(t),Qs=u(Q),pt=o(Q,"LI",{});var Ho=l(pt);Zs=i(Ho,"You can put a dummy Webhook URL for now. Defining your Webhook will let you look at the events that will be sent to it. You can also replay them, which will be useful for debugging!"),Ho.forEach(t),ea=u(Q),ht=o(Q,"LI",{});var Lo=l(ht);ta=i(Lo,"Input a secret to make it more secure."),Lo.forEach(t),sa=u(Q),ct=o(Q,"LI",{});var Co=l(ct);aa=i(Co,"Subscribe to \u201CRepo update\u201D events as we want to react to data changes"),Co.forEach(t),Q.forEach(t),Ft=u(e),xe=o(e,"P",{});var Io=l(xe);oa=i(Io,"Your Webhook will look like this:"),Io.forEach(t),Ut=u(e),He=o(e,"P",{});var Ro=l(He);Le=o(Ro,"IMG",{src:!0,alt:!0}),Ro.forEach(t),Dt=u(e),H=o(e,"H2",{class:!0});var ks=l(H);B=o(ks,"A",{id:!0,class:!0,href:!0});var No=l(B);ut=o(No,"SPAN",{});var Fo=l(ut);v(he.$$.fragment,Fo),Fo.forEach(t),No.forEach(t),la=u(ks),ft=o(ks,"SPAN",{});var Uo=l(ft);na=i(Uo,"Create a Space to react to your Webhook"),Uo.forEach(t),ks.forEach(t),Bt=u(e),M=o(e,"P",{});var js=l(M);ra=i(js,"We now need a way to react to your Webhook events. An easy way to do this is to use a "),ce=o(js,"A",{href:!0,rel:!0});var Do=l(ce);ia=i(Do,"Space"),Do.forEach(t),pa=i(js,"!"),js.forEach(t),Mt=u(e),Y=o(e,"P",{});var Es=l(Y);ha=i(Es,"You can find an example Space "),ue=o(Es,"A",{href:!0,rel:!0});var Bo=l(ue);ca=i(Bo,"here"),Bo.forEach(t),ua=i(Es,"."),Es.forEach(t),Yt=u(e),_=o(e,"P",{});var Z=l(_);fa=i(Z,"This Space uses Docker, Python, "),fe=o(Z,"A",{href:!0,rel:!0});var Mo=l(fe);da=i(Mo,"FastAPI"),Mo.forEach(t),ma=i(Z,", and "),de=o(Z,"A",{href:!0,rel:!0});var Yo=l(de);wa=i(Yo,"uvicorn"),Yo.forEach(t),ya=i(Z," to run a simple HTTP server. Read more about Docker Spaces "),me=o(Z,"A",{href:!0,rel:!0});var Ko=l(me);_a=i(Ko,"here"),Ko.forEach(t),ga=i(Z,"."),Z.forEach(t),Kt=u(e),K=o(e,"P",{});var $s=l(K);ba=i($s,"The entry point is "),we=o($s,"A",{href:!0,rel:!0});var Go=l(we);va=i(Go,"src/main.py"),Go.forEach(t),ka=i($s,". Let\u2019s walk through this file and detail what it does:"),$s.forEach(t),Gt=u(e),Ce=o(e,"OL",{});var Jo=l(Ce);L=o(Jo,"LI",{});var st=l(L);ja=i(st,"It spawns a FastAPI app that will listen to HTTP "),dt=o(st,"CODE",{});var Xo=l(dt);Ea=i(Xo,"POST"),Xo.forEach(t),$a=i(st," requests on "),mt=o(st,"CODE",{});var zo=l(mt);Pa=i(zo,"/webhook"),zo.forEach(t),qa=i(st,":"),st.forEach(t),Jo.forEach(t),Jt=u(e),v(ye.$$.fragment,e),Xt=u(e),_e=o(e,"OL",{start:!0});var Vo=l(_e);wt=o(Vo,"LI",{});var Qo=l(wt);Ie=o(Qo,"OL",{start:!0});var Zo=l(Ie);C=o(Zo,"LI",{});var at=l(C);Ta=i(at,"This route checks that the "),yt=o(at,"CODE",{});var el=l(yt);Sa=i(el,"X-Webhook-Secret"),el.forEach(t),Wa=i(at," header is present and that its value is the same as the one you set in your Webhook\u2019s settings. The "),_t=o(at,"CODE",{});var tl=l(_t);Aa=i(tl,"WEBHOOK_SECRET"),tl.forEach(t),Oa=i(at," secret must be set in the Space\u2019s settings and be the same as the secret set in your Webhook."),at.forEach(t),Zo.forEach(t),Qo.forEach(t),Vo.forEach(t),zt=u(e),v(ge.$$.fragment,e),Vt=u(e),be=o(e,"OL",{start:!0});var sl=l(be);gt=o(sl,"LI",{});var al=l(gt);xa=i(al,"The event\u2019s payload is encoded as JSON. Here, we\u2019ll be using pydantic models to parse the event payload. We also specify that we will run our Webhook only when:"),al.forEach(t),sl.forEach(t),Qt=u(e),G=o(e,"UL",{});var Ps=l(G);bt=o(Ps,"LI",{});var ol=l(bt);Ha=i(ol,"the event concerns the input dataset"),ol.forEach(t),La=u(Ps),vt=o(Ps,"LI",{});var ll=l(vt);Ca=i(ll,"the event is an update on the repo\u2019s content, i.e., there has been a new commit"),ll.forEach(t),Ps.forEach(t),Zt=u(e),v(ve.$$.fragment,e),es=u(e),ke=o(e,"OL",{start:!0});var nl=l(ke);je=o(nl,"LI",{});var qs=l(je);Ia=i(qs,"If the payload is valid, the next step is to create a project on AutoTrain, schedule a fine-tuning of the input model ("),kt=o(qs,"CODE",{});var rl=l(kt);Ra=i(rl,"microsoft/resnet-50"),rl.forEach(t),Na=i(qs," in our example) on the input dataset, and create a discussion on the dataset when it\u2019s done!"),qs.forEach(t),nl.forEach(t),ts=u(e),v(Ee.$$.fragment,e),ss=u(e),Re=o(e,"P",{});var il=l(Re);Fa=i(il,"Visit the link inside the comment to review the training cost estimate, and start fine-tuning the model!"),il.forEach(t),as=u(e),Ne=o(e,"P",{});var pl=l(Ne);Fe=o(pl,"IMG",{src:!0,alt:!0}),pl.forEach(t),os=u(e),Ue=o(e,"P",{});var hl=l(Ue);Ua=i(hl,"In this example, we used Hugging Face AutoTrain to fine-tune our model quickly, but you can of course plug in your training infrastructure!"),hl.forEach(t),ls=u(e),De=o(e,"P",{});var cl=l(De);Da=i(cl,"Feel free to duplicate the Space to your personal namespace and play with it. You will need to provide two secrets:"),cl.forEach(t),ns=u(e),J=o(e,"UL",{});var Ts=l(J);Be=o(Ts,"LI",{});var io=l(Be);jt=o(io,"CODE",{});var ul=l(jt);Ba=i(ul,"WEBHOOK_SECRET"),ul.forEach(t),Ma=i(io," : the secret from your Webhook."),io.forEach(t),Ya=u(Ts),S=o(Ts,"LI",{});var Se=l(S);Et=o(Se,"CODE",{});var fl=l(Et);Ka=i(fl,"HF_ACCESS_TOKEN"),fl.forEach(t),Ga=i(Se," : a User Access Token with "),$t=o(Se,"CODE",{});var dl=l($t);Ja=i(dl,"write"),dl.forEach(t),Xa=i(Se," rights. You can create one "),$e=o(Se,"A",{href:!0,rel:!0});var ml=l($e);za=i(ml,"from your settings"),ml.forEach(t),Va=i(Se,"."),Se.forEach(t),Ts.forEach(t),rs=u(e),X=o(e,"P",{});var Ss=l(X);Qa=i(Ss,"You will also need to tweak the "),z=o(Ss,"A",{href:!0,rel:!0});var po=l(z);Pt=o(po,"CODE",{});var wl=l(Pt);Za=i(wl,"config.json"),wl.forEach(t),eo=i(po," file"),po.forEach(t),to=i(Ss," to use the dataset and model of you choice:"),Ss.forEach(t),is=u(e),v(Pe.$$.fragment,e),ps=u(e),I=o(e,"H2",{class:!0});var Ws=l(I);V=o(Ws,"A",{id:!0,class:!0,href:!0});var yl=l(V);qt=o(yl,"SPAN",{});var _l=l(qt);v(qe.$$.fragment,_l),_l.forEach(t),yl.forEach(t),so=u(Ws),Tt=o(Ws,"SPAN",{});var gl=l(Tt);ao=i(gl,"Configure your Webhook to send events to your Space"),gl.forEach(t),Ws.forEach(t),hs=u(e),Me=o(e,"P",{});var bl=l(Me);oo=i(bl,"Last but not least, you\u2019ll need to configure your webhook to send POST requests to your Space."),bl.forEach(t),cs=u(e),Ye=o(e,"P",{});var vl=l(Ye);lo=i(vl,"Let\u2019s first grab our Space\u2019s \u201Cdirect URL\u201D from the contextual menu. Click on \u201CEmbed this Space\u201D and copy the \u201CDirect URL\u201D."),vl.forEach(t),us=u(e),Ke=o(e,"P",{});var kl=l(Ke);Ge=o(kl,"IMG",{src:!0,alt:!0}),kl.forEach(t),fs=u(e),Je=o(e,"P",{});var jl=l(Je);Xe=o(jl,"IMG",{src:!0,alt:!0}),jl.forEach(t),ds=u(e),ze=o(e,"P",{});var El=l(ze);no=i(El,"Update your Webhook to send requests to that URL:"),El.forEach(t),ms=u(e),Ve=o(e,"P",{});var $l=l(Ve);Qe=o($l,"IMG",{src:!0,alt:!0}),$l.forEach(t),ws=u(e),Ze=o(e,"P",{});var Pl=l(Ze);ro=i(Pl,"And that\u2019s it! Now every commit to the input dataset will trigger a fine-tuning of ResNet-50 with AutoTrain \u{1F389}"),Pl.forEach(t),this.h()},h(){h(f,"name","hf:doc:metadata"),h(f,"content",JSON.stringify(Ll)),h(d,"id","webhook-guide-setup-an-automatic-system-to-retrain-a-model-when-a-dataset-changes"),h(d,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(d,"href","#webhook-guide-setup-an-automatic-system-to-retrain-a-model-when-a-dataset-changes"),h(m,"class","relative group"),h(te,"href","https://huggingface.co/microsoft/resnet-50"),h(te,"rel","nofollow"),h(se,"href","https://huggingface.co/autotrain"),h(se,"rel","nofollow"),h(F,"id","prerequisite-upload-your-dataset-to-the-hub"),h(F,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(F,"href","#prerequisite-upload-your-dataset-to-the-hub"),h(O,"class","relative group"),h(oe,"href","https://huggingface.co/datasets/huggingface-projects/auto-retrain-input-dataset"),h(oe,"rel","nofollow"),h(le,"href","https://huggingface.co/docs/datasets/upload_dataset"),h(le,"rel","nofollow"),ot(Oe.src,ho="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/hub/webhooks-guides/002-auto-retrain/dataset.png")||h(Oe,"src",ho),h(Oe,"alt","dataset"),h(U,"id","create-a-webhook-to-react-to-the-datasets-changes"),h(U,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(U,"href","#create-a-webhook-to-react-to-the-datasets-changes"),h(x,"class","relative group"),h(re,"href","https://huggingface.co/settings/webhooks"),h(re,"rel","nofollow"),h(pe,"href","https://huggingface.co/datasets/huggingface-projects/input-dataset"),h(pe,"rel","nofollow"),ot(Le.src,co="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/hub/webhooks-guides/002-auto-retrain/webhook-creation.png")||h(Le,"src",co),h(Le,"alt","webhook-creation"),h(B,"id","create-a-space-to-react-to-your-webhook"),h(B,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(B,"href","#create-a-space-to-react-to-your-webhook"),h(H,"class","relative group"),h(ce,"href","https://huggingface.co/docs/hub/spaces-overview"),h(ce,"rel","nofollow"),h(ue,"href","https://huggingface.co/spaces/huggingface-projects/auto-retrain/tree/main"),h(ue,"rel","nofollow"),h(fe,"href","https://fastapi.tiangolo.com/"),h(fe,"rel","nofollow"),h(de,"href","https://www.uvicorn.org"),h(de,"rel","nofollow"),h(me,"href","https://huggingface.co/docs/hub/spaces-sdks-docker"),h(me,"rel","nofollow"),h(we,"href","https://huggingface.co/spaces/huggingface-projects/auto-retrain/blob/main/src/main.py"),h(we,"rel","nofollow"),h(Ie,"start","2"),h(_e,"start","2"),h(be,"start","3"),h(ke,"start","4"),ot(Fe.src,uo="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/hub/webhooks-guides/002-auto-retrain/notification.png")||h(Fe,"src",uo),h(Fe,"alt","community tab notification"),h($e,"href","https://huggingface.co/settings/tokens"),h($e,"rel","nofollow"),h(z,"href","https://huggingface.co/spaces/huggingface-projects/auto-retrain/blob/main/config.json"),h(z,"rel","nofollow"),h(V,"id","configure-your-webhook-to-send-events-to-your-space"),h(V,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(V,"href","#configure-your-webhook-to-send-events-to-your-space"),h(I,"class","relative group"),ot(Ge.src,fo="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/hub/webhooks-guides/002-auto-retrain/duplicate-space.png")||h(Ge,"src",fo),h(Ge,"alt","embed this Space"),ot(Xe.src,mo="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/hub/webhooks-guides/002-auto-retrain/direct-url.png")||h(Xe,"src",mo),h(Xe,"alt","direct URL"),ot(Qe.src,wo="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/hub/webhooks-guides/002-auto-retrain/update-webhook.png")||h(Qe,"src",wo),h(Qe,"alt","webhook settings")},m(e,n){s(document.head,f),p(e,w,n),p(e,m,n),s(m,d),s(d,W),k(g,W,null),s(m,A),s(m,P),s(P,R),p(e,ee,n),k(N,e,n),p(e,Ot,n),p(e,We,n),s(We,As),p(e,xt,n),p(e,q,n),s(q,Os),s(q,te),s(te,xs),s(q,Hs),s(q,se),s(se,Ls),s(q,Cs),p(e,Ht,n),p(e,O,n),s(O,F),s(F,lt),k(ae,lt,null),s(O,Is),s(O,nt),s(nt,Rs),p(e,Lt,n),p(e,T,n),s(T,Ns),s(T,oe),s(oe,Fs),s(T,Us),s(T,le),s(le,Ds),s(T,Bs),p(e,Ct,n),p(e,Ae,n),s(Ae,Oe),p(e,It,n),p(e,x,n),s(x,U),s(U,rt),k(ne,rt,null),s(x,Ms),s(x,it),s(it,Ys),p(e,Rt,n),p(e,D,n),s(D,Ks),s(D,re),s(re,Gs),s(D,Js),p(e,Nt,n),p(e,y,n),s(y,ie),s(ie,Xs),s(ie,pe),s(pe,zs),s(ie,Vs),s(y,Qs),s(y,pt),s(pt,Zs),s(y,ea),s(y,ht),s(ht,ta),s(y,sa),s(y,ct),s(ct,aa),p(e,Ft,n),p(e,xe,n),s(xe,oa),p(e,Ut,n),p(e,He,n),s(He,Le),p(e,Dt,n),p(e,H,n),s(H,B),s(B,ut),k(he,ut,null),s(H,la),s(H,ft),s(ft,na),p(e,Bt,n),p(e,M,n),s(M,ra),s(M,ce),s(ce,ia),s(M,pa),p(e,Mt,n),p(e,Y,n),s(Y,ha),s(Y,ue),s(ue,ca),s(Y,ua),p(e,Yt,n),p(e,_,n),s(_,fa),s(_,fe),s(fe,da),s(_,ma),s(_,de),s(de,wa),s(_,ya),s(_,me),s(me,_a),s(_,ga),p(e,Kt,n),p(e,K,n),s(K,ba),s(K,we),s(we,va),s(K,ka),p(e,Gt,n),p(e,Ce,n),s(Ce,L),s(L,ja),s(L,dt),s(dt,Ea),s(L,$a),s(L,mt),s(mt,Pa),s(L,qa),p(e,Jt,n),k(ye,e,n),p(e,Xt,n),p(e,_e,n),s(_e,wt),s(wt,Ie),s(Ie,C),s(C,Ta),s(C,yt),s(yt,Sa),s(C,Wa),s(C,_t),s(_t,Aa),s(C,Oa),p(e,zt,n),k(ge,e,n),p(e,Vt,n),p(e,be,n),s(be,gt),s(gt,xa),p(e,Qt,n),p(e,G,n),s(G,bt),s(bt,Ha),s(G,La),s(G,vt),s(vt,Ca),p(e,Zt,n),k(ve,e,n),p(e,es,n),p(e,ke,n),s(ke,je),s(je,Ia),s(je,kt),s(kt,Ra),s(je,Na),p(e,ts,n),k(Ee,e,n),p(e,ss,n),p(e,Re,n),s(Re,Fa),p(e,as,n),p(e,Ne,n),s(Ne,Fe),p(e,os,n),p(e,Ue,n),s(Ue,Ua),p(e,ls,n),p(e,De,n),s(De,Da),p(e,ns,n),p(e,J,n),s(J,Be),s(Be,jt),s(jt,Ba),s(Be,Ma),s(J,Ya),s(J,S),s(S,Et),s(Et,Ka),s(S,Ga),s(S,$t),s($t,Ja),s(S,Xa),s(S,$e),s($e,za),s(S,Va),p(e,rs,n),p(e,X,n),s(X,Qa),s(X,z),s(z,Pt),s(Pt,Za),s(z,eo),s(X,to),p(e,is,n),k(Pe,e,n),p(e,ps,n),p(e,I,n),s(I,V),s(V,qt),k(qe,qt,null),s(I,so),s(I,Tt),s(Tt,ao),p(e,hs,n),p(e,Me,n),s(Me,oo),p(e,cs,n),p(e,Ye,n),s(Ye,lo),p(e,us,n),p(e,Ke,n),s(Ke,Ge),p(e,fs,n),p(e,Je,n),s(Je,Xe),p(e,ds,n),p(e,ze,n),s(ze,no),p(e,ms,n),p(e,Ve,n),s(Ve,Qe),p(e,ws,n),p(e,Ze,n),s(Ze,ro),ys=!0},p(e,[n]){const Te={};n&2&&(Te.$$scope={dirty:n,ctx:e}),N.$set(Te)},i(e){ys||(j(g.$$.fragment,e),j(N.$$.fragment,e),j(ae.$$.fragment,e),j(ne.$$.fragment,e),j(he.$$.fragment,e),j(ye.$$.fragment,e),j(ge.$$.fragment,e),j(ve.$$.fragment,e),j(Ee.$$.fragment,e),j(Pe.$$.fragment,e),j(qe.$$.fragment,e),ys=!0)},o(e){E(g.$$.fragment,e),E(N.$$.fragment,e),E(ae.$$.fragment,e),E(ne.$$.fragment,e),E(he.$$.fragment,e),E(ye.$$.fragment,e),E(ge.$$.fragment,e),E(ve.$$.fragment,e),E(Ee.$$.fragment,e),E(Pe.$$.fragment,e),E(qe.$$.fragment,e),ys=!1},d(e){t(f),e&&t(w),e&&t(m),$(g),e&&t(ee),$(N,e),e&&t(Ot),e&&t(We),e&&t(xt),e&&t(q),e&&t(Ht),e&&t(O),$(ae),e&&t(Lt),e&&t(T),e&&t(Ct),e&&t(Ae),e&&t(It),e&&t(x),$(ne),e&&t(Rt),e&&t(D),e&&t(Nt),e&&t(y),e&&t(Ft),e&&t(xe),e&&t(Ut),e&&t(He),e&&t(Dt),e&&t(H),$(he),e&&t(Bt),e&&t(M),e&&t(Mt),e&&t(Y),e&&t(Yt),e&&t(_),e&&t(Kt),e&&t(K),e&&t(Gt),e&&t(Ce),e&&t(Jt),$(ye,e),e&&t(Xt),e&&t(_e),e&&t(zt),$(ge,e),e&&t(Vt),e&&t(be),e&&t(Qt),e&&t(G),e&&t(Zt),$(ve,e),e&&t(es),e&&t(ke),e&&t(ts),$(Ee,e),e&&t(ss),e&&t(Re),e&&t(as),e&&t(Ne),e&&t(os),e&&t(Ue),e&&t(ls),e&&t(De),e&&t(ns),e&&t(J),e&&t(rs),e&&t(X),e&&t(is),$(Pe,e),e&&t(ps),e&&t(I),$(qe),e&&t(hs),e&&t(Me),e&&t(cs),e&&t(Ye),e&&t(us),e&&t(Ke),e&&t(fs),e&&t(Je),e&&t(ds),e&&t(ze),e&&t(ms),e&&t(Ve),e&&t(ws),e&&t(Ze)}}}const Ll={local:"webhook-guide-setup-an-automatic-system-to-retrain-a-model-when-a-dataset-changes",sections:[{local:"prerequisite-upload-your-dataset-to-the-hub",title:"Prerequisite: Upload your dataset to the Hub"},{local:"create-a-webhook-to-react-to-the-datasets-changes",title:"Create a Webhook to react to the dataset's changes"},{local:"create-a-space-to-react-to-your-webhook",title:"Create a Space to react to your Webhook"},{local:"configure-your-webhook-to-send-events-to-your-space",title:"Configure your Webhook to send events to your Space"}],title:"Webhook guide: Setup an automatic system to re-train a model when a dataset changes"};function Cl(At){return Al(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ul extends ql{constructor(f){super();Tl(this,f,Cl,Hl,Sl,{})}}export{Ul as default,Ll as metadata};
